VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
END
Attribute VB_Name = "clsStation"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit

Const SND_ASYNC = 1
Const SND_NODEFAULT = 2

Private mintIndex As Integer
Private mstrCallsign As String
Private mdblLastHeard As Double
Private mdblRefLat As Double
Private mdblRefLong As Double
Private mdblLastLat As Double
Private mdblLastLong As Double
Private mdblDistance As Double
Private mdblBearing As Double
Private mblnHistory As Boolean
Private mstrHistory As String

Private Declare Function sndPlaySound Lib "winmm.dll" Alias "sndPlaySoundA" _
        (ByVal lpszSoundName As String, ByVal uFlags As Long) As Long

Private Sub AccumulateHistory(strH As String)
Dim intI As Integer
Dim blnPruned As Integer

'If the history is getting too long, then prune it.
'Do it in chunks so it's not being done every single
'time a beacon is received.
If Len(mstrHistory) > 10000 Then
    'Chop off about 2kb.
    mstrHistory = Right$(mstrHistory, 8000)
    intI = InStr(mstrHistory, vbCrLf)
    'Remove up to and including the next CrLf, so the
    'top of the history window is neat.
    If intI <> 0 Then mstrHistory = Mid$(mstrHistory, intI + 2)
    blnPruned = True
End If

If mstrHistory <> "" Then mstrHistory = mstrHistory & vbCrLf
mstrHistory = mstrHistory & strH

If mblnHistory Then
    If blnPruned Then
        ShowHistory mstrHistory, True
    Else
        ShowHistory strH, False
    End If
End If

End Sub

Public Property Let blnHistory(blnH As Boolean)

mblnHistory = blnH
If blnH Then ShowHistory mstrHistory, True

End Property


Private Function MakeMovementString() As String
Dim dblD As Double
Dim dblMultiplier As Double
Dim strF As String
Dim strUnits As String
Dim intB As Integer

dblD = mdblDistance
If frmMoveAlarm.gintUnits = Imperial Then
    dblMultiplier = 1760
Else
    dblMultiplier = 1000
End If


If dblD > dblMultiplier Then
    dblD = dblD / dblMultiplier
    strF = "0.0"
    strUnits = frmMoveAlarm.gstrBigUnits
Else
    strF = "0"
    strUnits = frmMoveAlarm.gstrSmallUnits
End If

intB = mdblBearing

MakeMovementString = Format$(dblD, strF) & strUnits & ", " & Format$(intB) & " deg"

End Function

Private Sub ShowHistory(strH As String, blnAll As Boolean)

frmMoveAlarm.ShowHistoryWindow mstrCallsign

If blnAll Then
    frmMoveAlarm.txtHistory = strH
    frmMoveAlarm.txtHistory.SelStart = &H7FFF
Else
    frmMoveAlarm.txtHistory.SelStart = &H7FFF
    If frmMoveAlarm.txtHistory <> "" Then _
        strH = vbCrLf & strH
    frmMoveAlarm.txtHistory.SelText = strH
End If

End Sub

Private Sub ShowText(txtT As TextBox, strA As String)

If Len(txtT) > 15000 Then txtT = Right$(txtT, 10000)
txtT.SelStart = &H7FFF
If txtT <> "" Then strA = vbCrLf & strA
txtT.SelText = strA

End Sub

Public Sub Init(intIndex As Integer)
Dim dblT As Double
Dim dblTI As Double
Dim strA As String
Dim cStInfo As New clsStationInfo
Dim cUIV As clsUIV
Dim intI As Integer

mintIndex = intIndex

Set cUIV = frmMoveAlarm.gUIV

'Ask UI-View32 for info in this station.
cStInfo.strCallsign = mstrCallsign
If cUIV.GetStationInfo(cStInfo) Then
    mdblRefLat = cStInfo.sngLat
    mdblRefLong = cStInfo.sngLong
    mdblLastLat = cStInfo.sngLat
    mdblLastLong = cStInfo.sngLong
End If

strA = cStInfo.strLastHeardRadio
If strA <> "" Then
    intI = Len(strA)
    dblT = DateValue(Left$(strA, intI - 5)) + TimeValue(Right$(strA, 5))
End If
    
strA = cStInfo.strLastHeardInet
If strA <> "" Then
    intI = Len(strA)
    dblTI = DateValue(Left$(strA, intI - 5)) + TimeValue(Right$(strA, 5))
End If

If dblTI > dblT Then dblT = dblTI
mdblLastHeard = dblT

If Not cUIV.AddToNotifyList(mstrCallsign) Then _
    MsgBox "An error occurred adding " & mstrCallsign & _
            " to the notification list.", vbExclamation, _
            MBOX_TITLE

DisplayStation

End Sub

Public Property Get intIndex() As Integer

intIndex = mintIndex

End Property

Public Property Let strCallsign(strC As String)

mstrCallsign = strC

End Property

Public Sub UpdateStInfo(sngLat As Single, sngLong As Single)
Dim strA As String
Dim strC As String * 10
Dim strTim As String
Dim strMove As String

strC = mstrCallsign
strTim = Format$(Now, "yyyy-mmm-dd hh:nn ")

mdblLastLat = sngLat
mdblLastLong = sngLong

If sngLat = SILLY_NEG Then
    strA = strTim & strC & "deleted in UI-View"
    ShowText frmMoveAlarm.txtStatus, strA
    Exit Sub
End If

'First beacon that's been heard, so set the ref position.
If mdblLastHeard = 0 Then
    'First beacon that's been heard from this station, so set the ref position.
    mdblRefLat = sngLat
    mdblRefLong = sngLong
Else
    'Get the distance and bearing, using the function in UI-View.
    frmMoveAlarm.gUIV.DistanceAndBearing mdblRefLat / 60, mdblRefLong / 60, _
            mdblLastLat / 60, mdblLastLong / 60, mdblDistance, mdblBearing, _
            (frmMoveAlarm.gintUnits = Metric)
            
    If frmMoveAlarm.gintUnits = Imperial Then
        mdblDistance = mdblDistance * 1760
    Else
        mdblDistance = mdblDistance * 1000
    End If
    
    If mdblDistance > Val(frmMoveAlarm.txtMinDist) Then
        strMove = MakeMovementString()
        strA = strTim & strC & "moved " & strMove
        ShowText frmMoveAlarm.txtStatus, strA
        
        'Update the reference location with this one.
        mdblRefLat = sngLat
        mdblRefLong = sngLong
        
        If frmMoveAlarm.gblnAudibleAlarm Then _
            sndPlaySound App.Path & "\WAV\SIREN.WAV", SND_NODEFAULT + SND_ASYNC
    End If

End If

mdblLastHeard = Now

DisplayStation

End Sub

Public Property Get strCallsign() As String
    
strCallsign = mstrCallsign

End Property

Private Sub Class_Initialize()

mdblRefLat = SILLY_NEG
mdblRefLong = SILLY_NEG
mdblLastLat = SILLY_NEG
mdblLastLong = SILLY_NEG
mdblDistance = SILLY_NEG

End Sub

Private Sub DisplayStation()
Const NO_LAT_LONG = "         -          "
Const NO_MOVEMENT = "       -"
Dim strA As String
Dim sngL As Single
Dim strLat As String
Dim strLong As String
Dim intI As Integer
Dim strT As String
Dim strMove As String
Dim strLast As String

On Error GoTo DisplayStationErr

strA = Left$(mstrCallsign & Space$(11), 11)

If mdblLastHeard <> 0 Then strT = Format$(mdblLastHeard, "hh:nn") Else strT = "  -  "
    
sngL = mdblLastLat
If sngL <> SILLY_NEG Then
    MakeLatLongString sngL, strLat, False
    sngL = mdblLastLong
    MakeLatLongString sngL, strLong, True
    strLast = strLat & " " & strLong
Else
    strLast = NO_LAT_LONG
End If

If mdblDistance > Val(frmMoveAlarm.txtMinDist) Then
    strMove = MakeMovementString()
Else
    strMove = NO_MOVEMENT
End If

strA = strA & strT & "  " & strLast & "  " & strMove

For intI = 0 To frmMoveAlarm.lstStations.ListCount - 1
    If frmMoveAlarm.lstStations.ItemData(intI) = mintIndex Then
        frmMoveAlarm.lstStations.List(intI) = strA
        Exit For
    End If
Next intI

'If not already in list then add it.
If intI = frmMoveAlarm.lstStations.ListCount Then
    frmMoveAlarm.lstStations.AddItem strA
    frmMoveAlarm.lstStations.ItemData(frmMoveAlarm.lstStations.NewIndex) = mintIndex
End If

AccumulateHistory strA

DisplayStationErr:
Exit Sub

End Sub

Private Sub MakeLatLongString(sngL As Single, strL As String, blnLong As Boolean)
Dim intD As Integer
Dim strF As String
Dim strP As String

If blnLong Then
    strF = "000"
    If sngL < 0 Then strP = "W" Else strP = "E"
Else
    strF = "00"
    If sngL < 0 Then strP = "S" Else strP = "N"
End If

sngL = Abs(sngL)
intD = sngL \ 60
sngL = sngL - intD * 60
strL = Format$(intD, strF) & "." & Format$(sngL, "00.00") & strP

'Needed because to replace decimal separator other than '.'
Mid$(strL, Len(strL) - 3) = "."

End Sub

Private Sub Class_Terminate()

If mblnHistory Then frmMoveAlarm.HideHistoryWindow False

End Sub


